String assembleStateArray()
{
  //This function creates a comma separated string called state,
  //this is the data that is sent from the Server to the Client
  //At the client, the data is parsed into a string array called str[]
  //With the index number the same as the sent parameter or data.
  //These strings are used to populate the web page using
  //HTML span controls as well as .InnerHTML , .value and .style properties.
  //In general each control has a control ID that is unique and permits
  //the updating of control text,value,colours from the web Socket State Array sent to the client.

  String state = "";//the data String
  String sep = ",";//the comma separator
  //Serial.println("****************************");
  //Serial.println ("HTML Mode is: " + htmlMode);
  if (htmlMode == "Main" )
  {
    state += htmlMode + sep; //0
    state += "" + sep; //1  //Was used for Page Title Now Spare
    //message = String (random(20));
    state += message + sep; //2
    state += String(brightness) + sep; //3
    if (year() == 1970 or timeString == "")
    {
      state += timeString + " " + location  + " Error - Clock Not synchronised." +  sep; //4
    }
    else
    {
      state += timeString + " " + location +  sep; //4
    }

    state += String (daylightSavings) + sep; //5
    state += String (defBrightness) + sep; //6
    if (duskToDawn == true)
    {
      dToDLightOnHour = sunsetTime.substring(0, sunsetTime.indexOf(":")).toInt();
      dToDLightOnMins = sunsetTime.substring(sunsetTime.indexOf(":") + 1 ).toInt();
      dToDLightOffHour = sunriseTime.substring(0, sunriseTime.indexOf(":")).toInt();
      dToDLightOffMins = sunriseTime.substring(sunriseTime.indexOf(":") + 1 ).toInt();

      state += String(dToDLightOnHour) + sep; //7
      state += String(dToDLightOnMins) + sep; //8
      state += String(dToDLightOffHour) + sep; //9
      state += String(dToDLightOffMins) + sep; //10
    }
    else
    {
      state += String(lightOnHour) + sep; //7
      state += String(lightOnMins) + sep; //8
      state += String(lightOffHour) + sep; //9
      state += String(lightOffMins) + sep; //10
    }
    state += sunsetTime + sep; //11
    state += sunriseTime + sep; //12
    if (lightOn == true)
    {
      state += "1" + sep;//13
    }
    else
    {
      state += "0" + sep;//13
    }
    state += String (alarmOn) + sep;//14
    state += String (alarmOnHour) + sep; //15
    state += String (alarmOnMins) + sep; //16
  }
  
  if (htmlMode == "AP" )
  {
    state += htmlMode + sep; //0
    state += "Network Settings" + sep;//1
    state += ssid + sep;//2

    //disguise Password
    String tempPw = "";
    if (password.length() >= 3)
    {
      String tempStar = "";
      for ( int i = 0; i < password.length()  - 2; i++)
      {
        tempStar += "*";
      }
      tempPw = password.substring(0, 1) + tempStar + password.substring(password.length() - 1);
    }
    state += tempPw + sep;//3
    state += ipToString(ipAdd) + sep;//4
    state += ipToString(ipGw) + sep;//5
    state += ipToString(ipDns) + sep;//6
    state += ipToString(ipSnm) + sep;//7
  }
  return state;
}
