void checkLightStatus()
{
  //Decides whether the LEDs should be on or off
  //Decides whether alarm should sound
  //Serial.println ("Time is: " +String (hour()) +":" + String( minute()) +":" +String (second()));
  //check if light should be on or off
  unsigned int onMins = 0;
  unsigned int offMins = 0;
  unsigned int nowMins = hour() * 60 + minute();
  if (alarmOn )
  {
    onMins = alarmOnHour * 60 + alarmOnMins; //17:50 = 1070
    if (onMins == nowMins and !alarmRunning)//Start the alarm if minutes equal if not running
    {
      message = "Alarm is Running.";
      alarmRunning = true;
      for (int i = 0; i < alarmDuration; i++)
      {
        digitalWrite(ledPin, LOW);//On Full Brightness
        digitalWrite (buzzPin, LOW); //Buzz On
        delay (500);
        digitalWrite(ledPin, HIGH);//Off
        digitalWrite (buzzPin, HIGH);
        delay (500);
        createTimeStr();
        handleWebSocket();
        if (alarmOn == false)//Stop if alarm turned off
        {
          break;
        }
      }
      message = "Alarm has finished Running.";
      lightOn = false;//to ensure it switches on if needed
    }
    else
    {
      //Reset alarm Running two minutes after started
      if (nowMins > onMins + 2 and alarmRunning )
      {
        alarmRunning = false;
        message = "Alarm Run has been re-set.";
      }
    }
  }
  if (manualOn == true)
  {
    lightOn = true;
    //message = "Light is On.";
    analogWrite(ledPin, ((100 - brightness) * 254) / 100);
    //Serial.println("ManualOn");
    return;//forget about it!
  }


  if (duskToDawn == true)
  {
    onMins = dToDLightOnHour * 60 + dToDLightOnMins; //17:50 = 1070
    offMins = dToDLightOffHour * 60 + dToDLightOffMins; //07:21 = 441

  }
  else
  {
    onMins = lightOnHour * 60 + lightOnMins; //17:50 = 1070
    offMins = lightOffHour * 60 + lightOffMins; //07:21 = 441

  }


  if ((onMins < offMins and (nowMins < onMins or nowMins >= offMins )) or ((onMins > offMins) and (nowMins >= offMins and nowMins < onMins)))
  {
    if (lightOn == true)//Turn Light Off Once
    {
      lightOn = false;
      message = "Light is Off.";
      digitalWrite(ledPin, HIGH);
    }
  }
  else
  {
    if (lightOn == false)//Turn Light On Once
    {
      lightOn = true;
      message = "Light is On.";
      analogWrite(ledPin, ((100 - brightness) * 254) / 100);
    }
  }


}
