time_t getNtpTime()
{
  //Gets NTP Time
  // Serial.println ("*********************************");
  //Serial.println ("TimeZone " + String (timeZone));
  //Serial.println ("*********************************");
  IPAddress ntpServerIP; // NTP server's ip address
  while (Udp.parsePacket() > 0) ; // discard any previously received packets
  //Serial.println("Transmit NTP Request");
  // get a random server from the pool
  WiFi.hostByName(ntpServerName, ntpServerIP);
  //Serial.print(ntpServerName);
  //Serial.print(": ");
  //Serial.println(ntpServerIP);
  sendNTPpacket(ntpServerIP);
  uint32_t beginWait = millis();
  while (millis() - beginWait < 1500)
  {
    int size = Udp.parsePacket();
    if (size >= NTP_PACKET_SIZE)
    {
      //Serial.println("Receive NTP Response");
      Udp.read(packetBuffer, NTP_PACKET_SIZE);  // read packet into the buffer
      unsigned long secsSince1900;
      // convert four bytes starting at location 40 to a long integer
      secsSince1900 =  (unsigned long)packetBuffer[40] << 24;
      secsSince1900 |= (unsigned long)packetBuffer[41] << 16;
      secsSince1900 |= (unsigned long)packetBuffer[42] << 8;
      secsSince1900 |= (unsigned long)packetBuffer[43];
      //Serial.println (String(secsSince1900 - 2208988800UL + ((timeZone * SECS_PER_HOUR)/10)));
      if (daylightSavings)
      {
        return secsSince1900 - 2208988800UL + (((timeZone + 10) * SECS_PER_HOUR) / 10);
      }
      else
      {
        return secsSince1900 - 2208988800UL + ((timeZone * SECS_PER_HOUR) / 10);
      }
    }
    if (syncTime == syncFast)
    {
      syncTime = syncSlow;
    }
    setSyncInterval(syncTime);
  }
  //Serial.println("No NTP Response :-(");
  return 0; // return 0 if unable to get the time

}
