String  get_MAIN_page()
{
  //NOTES:
  //Creates a string for HTML Page Load and Refresh. More difficult to read than
  //Using progmem string but more flexible
  //use escape(\) and quote(") for ClientToServer eg: \"ClientToServer('timeminus')\"
  //All other instances can use the single quote(')
  // escape and n before closing quotes  ...\n"; provides HTML line feed formatting

  String ht = "";

  ht += insertHTMLHead("Night Light"); //HTML Head Text and CSS Styles

  ht +=  "<body  id ='appBody'>\n";
  //ht +=  "<h3><span id = 'pagetitle'><span> </h3>\n";

  //Message Table
  ht += insertMessagesTable("Smart Night Light Messages:");

  //BRIGHTNESS
  ht += "<br>\n";
  ht += " <fieldset><legend>Brightness:</legend>\n";
  //ht += "<p>\n";
  ht += insertSlider("Brightness", "brightness", "H", 0, 100, brightness, true);
  ht += "<br>\n";

  //insertSelect(String label, String cId, String units, int sMin, int sMax, int sStep, String table)
  ht += insertSelect("Default Brightness is:", "defbrightness", " %", 0, 100, 1, "");

  //LED
  ht += "<button class='buttonled' id = 'ledlamp'><span id ='ledonoff'></span></button>\n";
  ht += "</fieldset>\n";

  //TIME:
  ht += " <fieldset><legend>Time:</legend>\n";
  ht +=  "<p><span id = 'time'><span> <h6> Clock is Local Computer Time</h6>\n";
  //ht += "<p>\n";
  ht += insertClock();
  ht += "<br>\n";

  //Options Select
  int range = 30;
  int aNum = 0;
  String values[range][2];
  values[aNum][0] = "O"; values[aNum][1] = "Options"; aNum++;
  values[aNum][0] = "Adelaide"; values[aNum][1] = "Adelaide"; aNum++;
  values[aNum][0] = "Brisbane"; values[aNum][1] = "Brisbane"; aNum++;
  values[aNum][0] = "Canberra"; values[aNum][1] = "Canberra"; aNum++;
  values[aNum][0] = "Darwin"; values[aNum][1] = "Darwin"; aNum++;
  values[aNum][0] = "Hobart"; values[aNum][1] = "Hobart"; aNum++;
  values[aNum][0] = "Melbourne"; values[aNum][1] = "Melbourne"; aNum++;
  values[aNum][0] = "Perth"; values[aNum][1] = "Perth"; aNum++;
  values[aNum][0] = "Sydney"; values[aNum][1] = "Sydney"; aNum++;
  values[aNum][0] = "O"; values[aNum][1] = "-- Alarm --"; aNum++;
  values[aNum][0] = "seta15"; values[aNum][1] = "15 secs"; aNum++;
  values[aNum][0] = "seta30"; values[aNum][1] = "30 secs"; aNum++;
  values[aNum][0] = "seta60"; values[aNum][1] = "60 secs"; aNum++;
  values[aNum][0] = "seta120"; values[aNum][1] = "120 secs"; aNum++;
  values[aNum][0] = "O"; values[aNum][1] = "--Clock--"; aNum++;
  values[aNum][0] = "clockon"; values[aNum][1] = "On"; aNum++;
  values[aNum][0] = "clockoff"; values[aNum][1] = "Off"; aNum++;
  values[aNum][0] = "O"; values[aNum][1] = "--Clock Brightness--"; aNum++;
  values[aNum][0] = "cbright0"; values[aNum][1] = "Minimum"; aNum++;
  values[aNum][0] = "cbright1"; values[aNum][1] = "Low"; aNum++;
  values[aNum][0] = "cbright2"; values[aNum][1] = "Medium"; aNum++;
  values[aNum][0] = "cbright3"; values[aNum][1] = "High"; aNum++;
  values[aNum][0] = "O"; values[aNum][1] = "--Wi Fi--"; aNum++;
  values[aNum][0] = "wifion"; values[aNum][1] = "Always On"; aNum++;
  values[aNum][0] = "wifioff"; values[aNum][1] = "Off in " + String (wifiTimer) + " mins"; aNum++;
  values[aNum][0] = "O"; values[aNum][1] = "------------"; aNum++;
  values[aNum][0] = "V"; values[aNum][1] = "Show Software Version"; aNum++;
  values[aNum][0] = "O"; values[aNum][1] = "------------"; aNum++;
  values[aNum][0] = "R"; values[aNum][1] = "Re-Boot Micro"; aNum++;
  values[aNum][0] = "N"; values[aNum][1] = "Network Reset"; aNum++;
  ht += insertSelectArray("Options:", "options", values, range);

  // Toggle Switches
  // String insertToggleSwitch(String tsLabel,String cId,bool state)
  ht += "<br>\n";
  ht += "<h4><table><th>Item</th><th>Off/On</th>\n";
  ht += "<tr><td>Daylight Savings:</td><td>\n";
  ht +=  insertToggleSwitch("", "dstoggle", daylightSavings );
  ht += "</td></tr>\n";

  ht += "<tr><td>Sunset to Sunrise:</td><td>\n";
  ht +=  insertToggleSwitch("", "sstoggle", duskToDawn);
  ht += "</td></tr>\n";

  ht += "<tr><td>Alarm:</td><td>\n";
  ht +=  insertToggleSwitch("", "atoggle", alarmOn);
  ht += "</td></tr>\n";

  ht += "<tr><td>Manual On:</td><td>\n";
  ht +=  insertToggleSwitch("", "mtoggle", manualOn);
  ht += "</td></tr>\n";
  ht += "</table></h4>\n";

  ht += "<br>\n";

  //insertSelectTime(String tsLabel, String cId,String type)
  ht += insertSelectTime("Light On Hour: ", "lightonhour", "H");
  ht += insertSelectTime("Minutes: ", "lightonmins", "M");
  ht += "<br><br>\n";

  ht += insertSelectTime("Light Off Hour: ", "lightoffhour", "H");
  ht += insertSelectTime("Minutes: ", "lightoffmins", "M");
  ht += "<br><br>\n";

  ht += insertSelectTime("Alarm On Hour: ", "alarmonhour", "H");
  ht += insertSelectTime("Minutes: ", "alarmonmins", "M");
  ht += "<br><br>\n";

  ht += "  Sunset: <span id = 'dusktime'> </span> \n";
  ht += "  Sunrise: <span id = 'dawntime'> </span> \n";
  ht += " </fieldset> \n";

  //Client to Server
  ht +=  "<script>\n";
  ht +=  "function ClientToServer(out) \n";
  ht +=  " {\n";
  ht +=      "connection.send(out + ':'); \n";
  //ht +=      "if (out.indexOf('jimbo') > -1 || out.indexOf('bjimbo') > -1 )\n";
  //ht +=      "{\n";
  //ht +=        "location.reload(); \n"; //refresh the whole page if new HTML Web Page data is sent
  //ht +=        "}\n";
  ht +=   "}\n";


  //Server to Client Web Socket Connection Data Comma Separated String
  ht +=  "var connection = new WebSocket('ws://' + location.hostname + ':81/', ['arduino']); \n";
  ht +=  "connection.onmessage = function (state) \n";
  ht +=  " {\n";
  ht +=  "  var str = state.data.split(','); \n";
  //State Array Items
  //htmlMode #0
  //pagetitle #1 not used
  //message #3
  //time #4
  //timezoneselect #5  not used
  //defbrightness #6
  //lightonhour #7
  //lightonmins #8
  //lightoffhour #9
  //lightoffmins #10
  //dusktime #11
  //dawntime #12
  //ledlamp #13
  //alarmon #14
  //alarmonhour #15
  //alarmonmins #16

  //alarmOn #14
  ht +=  "  var htmlMode = str[0]; \n";
  ht +=  "  if (htmlMode.indexOf('Main') > -1)\n";
  ht +=  "  {\n";
  //ht +=  "    var pT = document.getElementById('pagetitle'); \n";
  //ht +=  "    if (pT.innerHTML != str[1] ) pT.innerHTML = str[1]; \n";
  ht +=  "    var m1 = document.getElementById('message'); \n";
  ht +=  "    if (m1.innerHTML != str[2] ) m1.innerHTML = str[2]; \n";
  ht +=  "    document.getElementById('brightness').value = str[3]; \n";
  ht +=  "    document.getElementById('valuebrightness').innerHTML = str[3]; \n";
  ht +=  "    document.getElementById('time').innerHTML = str[4]; \n";
  //ht +=  "    document.getElementById('timezoneselect').selectedIndex = str[5]; \n";
  ht +=  "    document.getElementById('defbrightness').selectedIndex = str[6] ; \n";
  ht +=  "    document.getElementById('lightonhour').selectedIndex = str[7]; \n";
  ht +=  "    document.getElementById('lightonmins').selectedIndex = str[8]; \n";
  ht +=  "    document.getElementById('lightoffhour').selectedIndex = str[9]; \n";
  ht +=  "    document.getElementById('lightoffmins').selectedIndex = str[10]; \n";
  ht +=  "    document.getElementById('dusktime').innerHTML = str[11]; \n";
  ht +=  "    document.getElementById('dawntime').innerHTML = str[12]; \n";
  ht +=  "    var getled = document.getElementById('ledlamp') ; \n";
  ht +=  "    if (str[13] == '1')\n";
  ht +=  "    {\n";
  ht +=  "      getled.style.backgroundColor = 'white'; getled.style.color = 'black'; document.getElementById('ledonoff').innerHTML = 'On'; \n";
  ht +=  "    }\n";
  ht +=  "    if (str[13] == '0')\n";
  ht +=  "    {\n";
  ht +=  "      getled.style.backgroundColor = 'grey'; getled.style.color = 'white'; document.getElementById('ledonoff').innerHTML = 'Off'; \n";
  ht +=  "    }\n";
  ht +=  "    document.getElementById('alarmonhour').selectedIndex = str[15]; \n";
  ht +=  "    document.getElementById('alarmonmins').selectedIndex = str[16]; \n";

  ht +=  "   }\n";//If HTML Mode closing Brace
  ht +=  " }\n";//Function (state) closing Brace
  ht +=  " </script>\n";
  ht +=  " </body>\n";
  ht +=  " </html>\n";
  return ht;
}
